#include <bits/stdc++.h>

using namespace std;

const int MOD=1e9+7;

long long pow(long long a, long long b)
{
    if (b==0)
        return 1;
    if (b==1)
        return a%MOD;
    long long x=pow(a,b/2);
    long long y=pow(a,b%2);
    x*=x;
    x%MOD;
    x*=y;
    x%=MOD;
    return x;
}

vector <int> a,b;
int l[40010];
int r[80010];
int main()
{
    long long n,k;
    long long ans=0;
    cin>>n>>k;
    if ((n>=4*k+4) and (n>7000))
    {
    for (int i=1; i<=k; i++)
    {
        int x;
        cin>>x;
        if (x<2*k+2)
            a.push_back(x);
        if (n-x+1<2*k+2)
            b.push_back(n-x+1);
    }

    long long ans=0;
    for(int i=1; i<=2*k+10; i++)
        l[i]=1, r[i]=0;
    for (int i=0; i<a.size(); i++)
        l[a[i]]=0;
    a.clear();
    for (int i=1; i<=2*k+1; i++)
        if (l[i]==1)
        a.push_back(i);
    for (int i=0; i<a.size(); i++)
        for(int j=0; j<a.size(); j++)
            r[a[i]+a[j]]=1;

    for (int i=1; i<=2*k+1; i++)
        ans+=r[i];

    a=b;
    for(int i=1; i<=2*k+10; i++)
        l[i]=1, r[i]=0;

    for (int i=0; i<a.size(); i++)
        l[a[i]]=0;
    a.clear();
    for (int i=1; i<=2*k+1; i++)
        if (l[i]==1)
        a.push_back(i);
    for (int i=0; i<a.size(); i++)
        for(int j=0; j<a.size(); j++)
            r[a[i]+a[j]]=1;

    for (int i=1; i<=2*k+1; i++)
        ans+=r[i];

    cout<<2*n-(2*k+1)-(2*k+1)+ans+1<<"\n";
    return 0;
    }

    for (int i=1; i<=n; i++)
    l[i]=1;
    for (int j=1; j<=k; j++)
    {
        int x;
        cin>>x;
        l[x]=0;
    }
    for (int i=1; i<=n; i++)
        if (l[i]==1)
        a.push_back(i);
    for (int i=0; i<a.size(); i++)
        for(int j=0; j<a.size(); j++)
            r[a[i]+a[j]]=1;
    for (int i=1; i<=2*n; i++)
        ans+=r[i];
    cout<<ans<<"\n";
    return 0;
}
